/*
 * ARJ+xenu is based on open-source ARJ by Andrew Belov <andrew_belov@newmail.ru>.
 *
 * Copyright (C) 2011 Tomasz Konojacki <xenu@poczta.onet.pl>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * ---------------------------------------------------------------------------
 * Prototypes of the functions located in ARJ_XMS.ASM are declared here.
 *
 */

#ifndef ARJ_XMS_INCLUDED
#define ARJ_XMS_INCLUDED

/* XMS memory move structure */

struct xms_move
{
 unsigned long length;                  /* Must be even */
 short src_handle;                      /* Source handle */
 unsigned long src_offset;              /* Source offset */
 short dest_handle;                     /* Destination handle */
 unsigned long dest_offset;             /* Destination offset */
};

/* Prototypes */

int detect_xms();
void get_xms_entry();
int allocate_xms(unsigned short kbs, short *handle);
int free_xms(short handle);
int move_xms(struct xms_move *xms_mm);

#endif

