;*
;* ARJ+xenu is based on open-source ARJ by Andrew Belov <andrew_belov@newmail.ru>.
;*
;* Copyright (C) 2011 Tomasz Konojacki <xenu@poczta.onet.pl>
;*
;* This program is free software; you can redistribute it and/or
;* modify it under the terms of the GNU General Public License
;* as published by the Free Software Foundation; either version 2
;* of the License, or (at your option) any later version.
;*
;* This program is distributed in the hope that it will be useful,
;* but WITHOUT ANY WARRANTY; without even the implied warranty of
;* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;* GNU General Public License for more details.
;*
;* You should have received a copy of the GNU General Public License
;* along with this program; if not, write to the Free Software
;* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
;* ---------------------------------------------------------------------------
;* This code uses the  classic way  of determining what Intel x86 CPU is used.
;* The exact author is unknown.
;*

INCLUDE         ASM_INCL.INC

public          detect_x86

.CODE

;*
;* Returns one of the following values for corresponding CPU types:
;*
;*    0x0086 -> 8086/8088
;*    0x0186 -> 80186/80188
;*    0x0286 -> 80286
;*    0x0386 -> 80386 and higher
;*

detect_x86      proc
		pushf
		xor	ax, ax
		push	ax
		popf
		pushf
		pop	ax
		and	ax, 0F000h
		cmp	ax, 0F000h
		jnz	test_386
		push	cx
		mov	ax, 0FFFFh
		mov	cl, 21h
		shl	ax, cl
		pop	cx
		jnz	l186
		mov	ax, 86h
		popf
		jmp	short done
l186:
		mov	ax, 186h
		popf
		jmp	short done
test_386:
		mov	ax, 7000h
		push	ax
		popf
		pushf
		pop	ax
		and	ax, 7000h
		jnz	l386
		mov	ax, 286h
		popf
		jmp	short done
l386:
		mov	ax, 386h
		popf
		jmp	short $+2
done:
                ret
detect_x86      endp

        	end
